/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import com.rjconsultores.ventaboletos.entidad.Constante;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderConfiguracionGeneral;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Rafius
 */
@Controller("busquedaConfiguracionGeneralController")
@Scope("prototype")
public class BusquedaConfiguracionGeneralController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<Constante> plwConstante;
    private MyListbox constanteList;
    private Paging pagingConstante;
    private Textbox txtNombre;

    public Paging getPagingConstante() {
        return pagingConstante;
    }

    public void setPagingConstante(Paging pagingConstante) {
        this.pagingConstante = pagingConstante;
    }

    public MyListbox getConstanteList() {
        return constanteList;
    }

    public void setConstanteList(MyListbox constanteList) {
        this.constanteList = constanteList;
    }

    public PagedListWrapper<Constante> getPlwConstante() {
        return plwConstante;
    }

    public void setPlwConstante(PagedListWrapper<Constante> plwConstante) {
        this.plwConstante = plwConstante;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verPeriodo(new Constante());
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        constanteList.setItemRenderer(new RenderConfiguracionGeneral());
        constanteList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                Constante c = (Constante) constanteList.getSelected();
                verPeriodo(c);
            }
        });

        refreshLista();

        txtNombre.focus();
    }

    private void verPeriodo(Constante c) {
        if (c == null) {
            return;
        }

        Map args = new HashMap();
        args.put("constante", c);
        args.put("constanteList", constanteList);

        openWindow("/gui/configuraciones_comerciales/editarConfiguracionGeneral.zul",
                Labels.getLabel("editarConfiguracionGeneralController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<Constante> claseServicioBusqueda =
                new HibernateSearchObject<Constante>(Constante.class, pagingConstante.getPageSize());

        claseServicioBusqueda.addFilterLike("descconstante", "%" + txtNombre.getText().trim().concat("%"));
        claseServicioBusqueda.addFilterEqual("activo", Boolean.TRUE);
        claseServicioBusqueda.addSortAsc("nombconstante");

        plwConstante.init(claseServicioBusqueda, constanteList, pagingConstante);

        if (constanteList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaConfiguracionGeneralController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }
}
